/*
 *	MlpDeclaration.h
 *		version1.9.1
 */
/*
Copyright(c)2017-2022 ЃgXgE\tgEFAEVXe, All Rights Reserved.
*/

#ifndef	MLP_DECLARATION_H
#define	MLP_DECLARATION_H

typedef enum MlpPictureOpt {
	MLP_PICTURE_RGB = 0,
	MLP_PICTURE_GRAY,
	MLP_PICTURE_DITHER,
	MLP_PICTURE_BW,
	MLP_PICTURE_FAXG3,
	MLP_PICTURE_FAXG4,

	MLP_COMPRESS_NONE,			/*TIFFϊ̏ꍇɈkȂ*/
	MLP_COMPRESS_JPEG,			/*TIFFϊ̏ꍇJPEGk*/
	MLP_COMPRESS_DEFLATE,		/*TIFFϊ̏ꍇDeflatek*/
	MLP_COMPRESS_LZW,			/*TIFFϊ̏ꍇLZWk*/

	MLP_JPEG_QUALITY,			/*JPEGk̉摜i*/

	MLP_RESOLUTION_DPI,			/*XDPI,YDPIol̉𑜓x*/
	MLP_RESOLUTION_XDPI,		/*XDPI 𑜓x*/
	MLP_RESOLUTION_YDPI,		/*YDPI 𑜓x*/
	MLP_CANVAS_SIZE,			/*LoXTCY XYow*/
	MLP_CANVAS_XSIZE,			/*LoXTCY X-݂̂w*/
	MLP_CANVAS_YSIZE,			/*LoXTCY Y-݂̂w*/
	MLP_PICTURE_XSIZE,			/*_TCYw*/
	MLP_PICTURE_YSIZE,			/*_TCYw*/
	MLP_PICTURE_SIZE_UNIT,		/*_TCY̒P*/
	MLP_PICTURE_USE_MEDIABOX,	/*y[W̋EMediaBoxɂ*/
	MLP_PICTURE_USE_CROPBOX,	/*y[W̋ECropBoxɂ*/
	MLP_PICTURE_USE_BLEEDBOX,	/*y[W̋EBleedBoxɂ*/
	MLP_PICTURE_USE_TRIMBOX,	/*y[W̋ETrimBoxɂ*/
	MLP_PICTURE_USE_ARTBOX,		/*y[W̋EArtBoxɂ*/
	MLP_PIXEL_SIZE_X,			/*sNZPʂ̉摜*/
	MLP_PIXEL_SIZE_Y,			/*sNZPʂ̉摜*/
	MLP_FILL_PATH_AA,			/*tBpX̃A`ACAX*/
	MLP_CID_0_GLYPH,			/*R[h0̃Ot 0:notdef\, 1:(gid=0)\, 2:̕𖳎*/
	MLP_TRUNCATE_PAGE_BBOX,		/*y[WE𐮐ۂɏ؂̂ď(MediaBox̏ꍇ)*/
	MLP_PAGE_CLIP_VALUE,		/*y[Ẅ̗wlsNZȗ̈ŃNbv*/
	MLP_STROKEPATH_MINIMUM_LINE_WIDTH,	/*pX̃Xg[Nɂŏw*/

	MLP_THRESHOLD_BITONAL,		/*l臒l*/
	MLP_THRESHOLD_DITHER,		/*fBU臒l*/

	MLP_PICTURE_CMYK=36,		/*CMYKF*/
	MLP_ANTIALIAS_LEVEL,		/*A`ACAX̃x*/
	MLP_DATA_COMPRESSION_LEVEL,	/*f[^k̃x*/
	MLP_PICTURE_USE_MEDIA_CROP=43,	/*y[W̋EMediaBox܂CropBox̏ɂ*/
	MLP_OCG_USAGE=44,			/*0:"view", 1:"Print", 2:"Export"*/
	MLP_TEXT_ANTIALIAS,			/*1:eLXg̃A`ACAXL()A0:*/
	MLP_XY_PIXEL_SIZE_MEM=47,	/*oオ摜f[^̕TCY (cłꂼDPIɐݒ肳)*/
#if	0
	MLP_TR2_TO_BOLDEN=48,		/*eLXgFill the Stroke𑾕`ɕύX*/
	MLP_TR2_TO_FILL=49,			/*eLXgFill the StrokeFill݂̂ɕύX*/
	MLP_TR2_TO_STROKE=50,		/*eLXgFill the StrokeStrokê݂ɕύX*/
#else
	MLP_REPLACE_TR2_MODE=48,	/*eLXgFill then Stroke`ύX 0:]ǂA1:Fill`A2:Stroke`*/
#endif
	MLP_BITMAP_IMG_FORMAT=53,	/*BMP`̃f[^tH[}bg 0:WindowsA1:OS/2*/
	MLP_CANVAS_ORIGIN=54,		/*LoXTCYύX̌_w*/
	MLP_USE_ZERO_LINE_WIDTH=55,	/*[̃Xg[Nɑ΂A0:PsNZɕύX(݊)A1:A`ACAX̃xɕύX*/
	MLP_ROTATE_PAGE_IMAGE=60,		/*PDF̌݃y[WꎞIɉ]*/

	MLP_STROKEPATH_ENABLE_CALLBACK=1001,	/*Xg[NpX̃R[obNLɂ*/
	MLP_TILE_IMAGE_ENABLE_CALLBACK,			/*^C摜̃R[obNLɂ*/
	MLP_TILE_MASK_IMG_ENABLE_CALLBACK,		/*^C}XN摜̃R[obNLɂ*/
	MLP_TILING_ENABLE_CALLBACK,				/*^CÕR[obNLɂ*/
	MLP_TILING_IGNORE_PROCESS,				/*^COSɖ(̋@\̓T|[gȂ)*/
	MLP_SUPPRESS_ALPHA_CHANNEL_ON_CB,		/*R[obN̉摜f[^ɃAt@`ll܂߂Ȃ*/
	MLP_ALLOW_PDF_14_TO_17=1101,		/*PDFo[W 1.4->1.7*/
	MLP_ALLOW_PDF_10_TO_17,				/*PDFo[W 1.0->1.7*/
	MLP_ALLOW_PDF_14_TO_20,				/*PDFo[W 1.4->1.7,2.0*/
	MLP_ALLOW_PDF_ALL,					/*PDFo[W 1.0->1.7,2.0*/

} MlpPictureOpt;

typedef enum MlpDocumentOpt {
	MLP_PERMISSION_FLAG=1201,	/*̃p[~bVtO*/
	MLP_OCG_COUNT,				/*OCG̑*/
	MLP_GLYPH_NOT_FOUND_COUNT,	/*OtłȂ*/
	MLP_PDF_AUTHOR,
	MLP_NEEDS_PASSWORD,			/*0:ÍA1:NULLpX[hŃI[vA2:pX[hKv*/
	MLP_PRINT_RESTRICTION=1207,	/*ꂽ𑜓xtOl 1:肳ꂽ(𑜓x)A0:(𑜓x)*/
	MLP_DOCUMENT_TITLE=1211,	/*PDF̃^Cg*/
	MLP_CREATION_DATE,			/**/
	MLP_MODIFICATION_DATE,		/*ŐV̕ύX*/
	MLP_ENCRYPT_VERSION,		/*̈Ío[W*/
	MLP_ENCRYPT_REVISION,		/*̈ÍrW*/
	MLP_PDF_VERSION,			/*PDF̃o[W*/
} MlpDocumentOpt;

typedef enum MlpLibraryOpt {
	MLP_LOGICAL_CPU_COUNT=101,		/*_ICPȖ _not used_ */
	MLP_THREAD_SPLIT_PAGE=102,		/*y[W𕡐̃XbhŎs*/
	MLP_THREAD_SPLIT_PAGE_COUNT,	/*y[W𕪊Xbh̐*/
	MLP_THREAD_EACH_PAGE,			/*ey[Wʂ̃XbhŎs*/
	MLP_THREAD_EACH_PAGE_COUNT,		/*iy[WXbh̐*/

	MLP_LICENSE_ERROR_INFO = 1201,	/*sCZX̏ڍ׏*/
} MlpLibraryOpt;

typedef enum MlpPictureUnit_e {
	MLP_PICTURE_UNIT_PERCENT	= 1,		/*摜̘_TCYw肷ۂ̒Pʂp[Zg*/
	MLP_PICTURE_UNIT_INCH		= 2,		/*摜̘_TCYw肷ۂ̒PʂC`*/
	MLP_PICTURE_UNIT_MM			= 3,		/*摜̘_TCYw肷ۂ̒Pʂ~[g[mm]*/
} MlpPictureUnit;

typedef enum MlpCallbackSettingMode {
	MLP_RENDERING_CB=1,				/*y[W̉͏I / _O̊Jnm点R[obNw*/
	MLP_PROGRESS_CB,				/*w肵s̃_Oi摜i[jIƂm点R[obNw*/
	MLP_RENDERED_CB,				/*y[W̃_OIm点R[obNw*/

	MLP_DRAW_STROKE_PATH_CB=101,	/*pX̃Xg[LOƂɃR[obN*/
	MLP_DEFINE_IMAGE_TILE_CB,		/*^C`ꂽƂɃR[obN*/
	MLP_DEFINE_MASK_IMAGE_TILE_CB,	/*^C̃}XN`ꂽƂɃR[obN*/
	MLP_DRAW_TILED_IMAGE_CB,		/*^COꂽ摜\tƂɃR[obN*/
} MlpCallbackSettingMode;

typedef enum MlpTiffCompressMode {
	MLP_TIFF_COMPRESS_NONE=0,		/*TIFFϊňkȂ*/
	MLP_TIFF_COMPRESS_JPEG,			/*TIFFϊJPEGk*/
	MLP_TIFF_COMPRESS_DEFLATE,		/*TIFFϊDeflatek*/
	MLP_TIFF_COMPRESS_LZW,			/*TIFFϊLZWk*/
} MlpTiffComtressMode;

typedef enum MlpConstants {
	MIN_RESOLUTION		= 10,		/*ŏ̉𑜓xύX*/
	MAX_RESOLUTION		= 10000,
	DEFAULT_RESOLUTION	= 150,
	MIN_JPEG_QUALITY	= 10,
	MAX_JPEG_QUALITY	= 90,
	DEFAULT_JPEG_QUALITY= 75,

	MIN_PIXEL_SIZE		= 200,
	MAX_PIXEL_SIZE		= 5000000,

	LICENSE_0_LENGTH	= 19,		/*version 0 CZXL[̒*/
	LICENSE_1_LENGTH	= 27,		/*version1.0 CZXL[̒*/

	DEFAULT_MULTILINE_TEXT_WIDGET_FONT_SIZE	= 55,	/*}`CTextWidget(Form Annotation)̃tHg̊TCY(l͎TCŶPO{)*/

	CONVERT_CMYK_TO_RGB		= 1,	/*CMYKRGBւ̕ϊ*/
	CONVERT_MOST_FAST		= 1,	/*ł*/
	CONVERT_FAST			= 2,	/**/
	CONVERT_BY_COLOR_PROFILE= 3,	/*J[vt@Cɂϊ*/
} MlpConstants;

typedef enum MlpCid0GlyphMode {
	SHOW_NOTDEF_GLYPH		= 0,
	REPLACE_TO_BLANK_GLYPH	= 1,
	IGNORE_CID_0_GLYPH		= 2,
} MlpCid0GlyphMode;

typedef enum MlpBoundaryBox {
	MEDIA_BOX		= 0,
	CROP_BOX		= 1,
	BLEED_BOX		= 2,
	TRIM_BOX		= 3,
	ART_BOX			= 4,
} MlpBoundaryBox;

typedef	enum MlpWatermarkLayer {
	WML_NO_PAINT	= 0,
	WML_FOREGROUND	= 1,
	WML_BACKGROUND	= 2,
} MlpWatermarkLayer;

typedef enum MlpCanvasOrigin {
	CORIGIN_CENTER		= 0,
	CORIGIN_LEFT_TOP	= 1,
	CORIGIN_LEFT_BOTTOM	= 2,
	CORIGIN_RIGHT_TOP	= 3,
	CORIGIN_RIGHT_BOTTOM= 4,
}MlpCanvasOrigin;

typedef	struct MlpOcgDataRec_s MlpOcgDataRec_t;
typedef	struct MlpOcgUsageRec_s MlpOcgUsageRec_t;
typedef	MlpOcgDataRec_t	MlpOcgData;
typedef	MlpOcgUsageRec_t	MlpOcgUsage;

#define	MAX_OCG_NAME_LEN	100

struct MlpOcgDataRec_s {
	int		id;
	char	name[MAX_OCG_NAME_LEN+1];
	int		level;
	int		visible;
};

struct MlpOcgUsageRec_s {
	int		id;
	char	name[MAX_OCG_NAME_LEN+1];
	int		level;
	int		visible;

	/*Usage*/
	int	printState;
	int	viewState;
};

#ifndef	STROKE_PATH_ATTR_DEF
typedef struct StrokePathAttr_s {
	float	lineWidth;
	int		lineCap;
	int		lineJoin;
	float	miterLimit;

	int		dashLen;
	float	dashPhase;
	float	dashData[32];

	float	colorfv[5];

	char	*pathString;

	int		x, y, width, height;
	int		colors;
} StrokePathAttr;
#endif

#ifndef	IMAGE_TILE_ATTR_DEF
typedef	struct Matrix_s {
	float	a, b, c, d, e, f;
} Matrix;

typedef struct ImageTileAttr_s {
	int		width, height, colors;
	float	alpha;
	float	xstep, ystep;
	Matrix	ctm;
} ImageTileAttr;
#endif

typedef struct MlpFormData_s {
	int			type;
	const char	*name;
	int			valueLength;
	const char	**value;		//[ol,\l]yA̔z
	const char	*richText;
	const char	**(*GetValue)(struct MlpFormData_s*, int);
} MlpFormData;

/* Metadata ֘A */
typedef	struct MlpMetadataProperty_s		MlpMetadataProperty;
typedef	struct MlpMetaSimpleProperty_s		MlpMetaSimpleProperty;
typedef	struct MlpMetaArrayProperty_s		MlpMetaArrayProperty;
typedef	struct MlpMetaStructProperty_s		MlpMetaStructProperty;

struct MlpMetaSimpleProperty_s {
	wchar_t	*property;
	wchar_t	*value;
};

struct MlpMetaArrayProperty_s {
	wchar_t	*property;
	wchar_t	**valueAry;
	unsigned int	value_count;
};

struct MlpMetaStructProperty_s {
	wchar_t	*property;
	wchar_t	**fieldAry;
	wchar_t	**valueAry;
	unsigned int	value_count;
};

struct MlpMetadataProperty_s {
	MlpMetaSimpleProperty	*simple_property;
	unsigned int	simple_count;

	MlpMetaArrayProperty	*array_property;
	unsigned int	array_count;

	MlpMetaStructProperty	*structure_property;
	unsigned int	structure_count;
};

/*
**	^f[^AXMP
*/
typedef	void* METADATA_HANDLE;
typedef	void* XMP_TK_HANDLE;

/*
 *	͗p
 */

typedef	struct PrsFontName_s PrsFontName;

struct PrsFontName_s {
	int		pageNum;		/*tHggĂy[Wԍ*/
	char	fontId[256];	/*tHg̎ʖ*/
	char	fontName[256];	/*tHg*/
	int		embedded;		/*1:ߍ܂ꂽtHgA0:ȊO*/
	int		render;			/*-1:_[[h̎w肪ȂA0:ʏ̃_[[hŗpĂA1:Tr=2̃_[[hŎgpĂ*/
};

/*
**	PrimitiveC^[tF[X
*/

typedef	void* PRIMITIVE_HANDLE;

typedef	struct PrmObjectHandle_s	PrmObjectHandle;
typedef	struct PrmDocumentXref_s	PrmDocumentXref;
typedef	enum PrmObjectType_e		PrmObjectType;
typedef	enum PrmXRefType_e			PrmXrefType;

struct PrmObjectHandle_s {
	PrmObjectType type;
	unsigned __int64 handle;
	int num;
};

struct PrmDocumentXref_s {
	int		ofs;
	int		num;
	int		gen;
	char	type;
};

enum PrmObjectType_e {
	PRM_UNKNOWN_OBJ = 0,
	PRM_NUL_OBJ = 1,
	PRM_NULL_OBJ = PRM_NUL_OBJ,
	PRM_BOOL_OBJ,
	PRM_INT_OBJ,
	PRM_REAL_OBJ,
	PRM_NMBER_OBJ,
	PRM_STRING_OBJ,
	PRM_NAME_OBJ,
	PRM_ARRAY_OBJ,
	PRM_DICTIONARY_OBJ,
	PRM_INDIRECT_OBJ,
	PRM_NUMBER_OF_OBJS,
};

enum PrmXRefType_e {
	PRM_XREF_TABLE = 0,
	PRM_XREF_STREAM,
};

#endif	/*MLP_DECLARATION_H*/
