#
#	toJPEG Sample application
#

##
##	Copyright(c) 2022 株式会社トラスト・ソフトウェア・システム,All Rights Reserved.
##

#
#<ImagerLPインストールフォルダー>は適切なフォルダーに、
#<Platform>はx64またはWin32に変更してください。
#import sys
#sys.path.insert(1,'<ImagerLPインストールフォルダー>\\lib\\<Platform>')
#
from PdfImagerLP import Mlp,MlpConstant as kMlp

mlp=Mlp()
if mlp.Initialize("0-0GK0-E131817KW067") != 0:
	print("Bad License Key.")
	exit()
mlp.ShowLicenseInfo()

if mlp.OpenDoc('../hw-5p.pdf') < 0:
	print('オープンできません')
else:
	print('総ページ数 = ', mlp.PageCount())
	mlp.SetPictureSize(0,30,kMlp.PICTURE_UNIT_PERCENT)
	mlp.SetPictureResolution(150)
	mlp.SetPictureQuality(75)
	if mlp.CreatePict(1,'out.png') < 0:
		print('画像作成失敗')
	mlp.CloseDoc()

mlp.Uninitialize()
