/*
**	MplError.h
**	version 1.9.1
*/
/*
Copyright(c)2014-2022 ЃgXgE\tgEFAEVXe, All Rights Reserved.
*/

#ifndef	MLP_ERROR_H
#define	MLP_ERROR_H

#define	MLP_NO_ERROR				0
#define	MLP_ALREADY_INITIALIZED		-1		/*ɏĂ܂*/
#define	MLP_NOT_INITIALIZED			-2		/*ł܂łB܂́AĂ܂*/
#define	MLP_INIT_FILE_OPEN_ERROR	-3		/*t@Cǂ߂܂*/
#define	MLP_INIT_DATA_LOAD_ERROR	-3		/*[fBOł܂*/
#define	MLP_LICENSE_ERROR			-4		/*sȃCZXł*/
#define	MLP_ALREADY_OPENED			-5		/*ɃI[vĂ܂*/
#define	MLP_FILE_OPEN_ERROR			-6		/*I[vł܂*/
#define	MLP_FILE_IS_NOT_PDF			-7		/*PDFł͂Ȃ悤ł*/
#define	MLP_UNRECOGNIZED_FILE		-7		/*FłȂt@Cł*/
#define	MLP_FILE_NOT_DECRYPTED		-8		/*ł܂*/
#define	MLP_FILE_NOT_OPENED			-9		/*I[vĂ܂*/
#define	MLP_OPEN_ERROR				-10		/*I[vŃG[*/
#define	MLP_PDF_PARSE_ERROR			-11		/*PDF̉̓G[*/
#define	MLP_PDF_HAS_NOT_PAGE		-12		/*PDF(w)y[W܂*/
#define	MLP_INVALID_PAGE_NUMBER		-13		/*ȃy[Wԍ ܂́Aȃy[Ww*/
#define	MLP_INVALID_RESOLUTION		-14		/*ȉ𑜓x*/
#define	MLP_INVALID_QUALITY			-15		/*JPEGi*/
#define	MLP_NO_OUTPUT_FILE			-16		/*o̓t@C܂*/
#define	MLP_TOO_LARGE_PIXEL			-17		/*sNZ }bv傫܂*/
#define	MLP_DRAW_ERROR				-18		/*`̈mۂɎsB܂́A摜̏oɎs܂*/
#define	MLP_MEMORY_ERROR			-20		/*[̈mۂł܂*/
#define	MLP_INVALID_CANVAS_SIZE		MLP_INVALID_ARG_VALUE		/*ȃLoXTCY*/
#define	MLP_INVALID_ARG_VALUE		-22		/*Ȉ̒l*/
#define	MLP_INVALID_PICT_TYPE		-23		/*ȉ摜`*/
#define	MLP_INVALID_CMD				-24		/*ȃR}h*/
#define	MLP_NO_DATA					-25		/*Lȃf[^܂*/
#define	MLP_FILL_1					-26
#define MLP_FAIL_TO_GET_PAGE		-27		/*y[W̎擾Ɏs܂*/
#define	MLP_INVALID_DATA			-30		/*ȃf[^*/
#define	MLP_NO_LICENSE_KEY			-31		/*CZXL[w肳Ă܂*/
#define	MLP_UNUSABLE_LICENSE		-32		/*̃o[Wł͎gȂCZXł*/
#define	MLP_EXPIRED_LICENSE			-33		/*CZXł*/
#define	MLP_ILLEGAL_OS_LICENSE		-34		/*OSł͎gȂCZXł*/
#define	MLP_OUT_OF_BOUND			-35		/*l͈͊Oł*/
#define	MLP_COLOR_PROFILE_NOT_FOUND	-36		/*J[vt@Cǂݍ߂܂*/
#define	MLP_INVALID_VER_COLOR_PROFILE -37	/*ver.2ł͂ȂJ[vt@C*/
#define	MLP_INVALID_COLOR_PROFILE	-38		/*sȃJ[vt@C*/
#define MLP_FAIL_TO_COUNT_PAGES		-39		/*y[W̎擾Ɏs܂*/
#define MLP_INVALID_PDF_VERSION		-40		/*sPDF̃o[Wł*/
#define	MLP_FONT_NOT_FOUND			-41		/*tHg܂*/
#define	MLP_ALT_FONT_NOT_FOUND		-42		/*փtHg܂*/
#define	MLP_FONT_FILE_NOT_OPENED	-43		/*tHgt@CJ܂*/
#define	MLP_FONT_NOT_LOADED			-44		/*tHg[hł܂*/
#define	MLP_GLYPH_NOT_FOUND			-51		/*Otł܂*/
#define	MLP_UNAVAILABLE_CMD			-61		/*ps\ȃR}h*/
#define	MLP_NO_METADATA				-71		/*^f[^܂*/
#define	MLP_COULDNT_PARSE_XML		-72		/*XML͂ł܂*/
#define	MLP_INVALID_METADATA		-73		/*sȃ^f[^*/
#define	MLP_COULDNT_PARSE_METADATA	-74		/*^f[^͂ł܂*/
#define	MLP_XMP_INVALID_NS_URI		-75		/*sNamespaceURI*/
#define	MLP_XMP_PROPERTY_NOT_EXIST	-76		/*̃vpeB͂܂*/
#define	MLP_XMP_NOT_SIMPLE_PROPERTY	-81		/*vpeBSimplePropertył͂܂*/
#define	MLP_XMP_NOT_ARRAY_PROPERTY	-82		/*vpeBArrayPropertył͂܂*/
#define	MLP_XMP_ARRAY_HAS_NO_ITEMS	-83		/*vpeBArrayPropertyłAACe܂*/
#define	MLP_XMP_TOO_BIG_ARRAY_INDEX	-84		/*vpeBArrayPropertyłAACeԍ傫܂*/
#define	MLP_XMP_NOT_STRUCT_PROPERTY	-85		/*vpeBStructPropertył͂܂*/
#define MLP_XMP_FEILD_NOT_EXITS		-86		/*vpeBStructPropertyłÃtB[h͂܂*/
#define	MLP_XMP_ERROR				-91		/*XMP Toolkit̃G[*/

#endif	/*MLP_ERROR_H*/
